#include <iostream>
#include <vector>
using namespace std;
const int N = 500005;
int digits[N][65];
int num_of_digits[65];
long long numbers[N];
//vector<int> dig;
int main()
{
    ios :: sync_with_stdio(false);
    int n;
    cin >> n;
    int cnt = 0;
    int cnt0 = 0;
    int num0 = 0;
    for(int i=0; i<n; i++)
    {
        int k;
        cin >> k;
        numbers[i]=k;
        cnt += 1-k%2;
        if(k==0)
            cnt0++;

        int deg;
        for(deg=0; k>0; deg++, k/=2);
        deg--;
        k = numbers[i];
        //cout << deg << endl;
        for(int j=deg; k>0; j--, k/=2)
        {
            //digits[i][j]=k%2;
            num_of_digits[j]+=k%2;
        }
    }
    for(int i=1; i<=64; i++)
        num0 += num_of_digits[i]%2;
    num0+= n%2;

    if(cnt0==cnt)
        while(true);

    if(cnt0==cnt && num0==0 )
        cnt+=2;
    cout << cnt;
    return 0;
}